function C=buildC(S)
% C=buildC(S)
% Построение матрицы кросс-корреляций (вариант - большая статья)
% Аргументы  : S - исходная матрица
% Результаты : C - матрица коэффициентов кросс-корреляции

[m,n]=size(S);               % Определяем размеры S
n=n-1;
G=zeros(m,n-1);
for i=1:n                    % Строим матрицу G
    G(:,i)=log(S(:,i+1))-log(S(:,i));
end
for j=1:m                    % Строим матрицу g
    sigma=0;
    for k=1:n
        sigma=sigma+G(j,k)*G(j,k);
    end
    sigma=sigma/n;
    avg=sum(G(j,:))/n;
    sigma=sqrt(sigma-avg*avg);
    for i=1:n
        g(j,i)=(G(j,i)-avg)/sigma;
    end
end
for i=1:m                    % Строим матрицу C
    for j=1:m
        summa=0;
        for k=1:n
                summa=summa+g(i,k)*g(j,k);
        end
        C(i,j)=summa/n;
    end
end
for i=1:m
    C(i,i)=1;
end